import java.awt.Point;

//
// 変数の準備
//
PImage[] images;
int[][] map = {
  {1,1,1,1,1,1,1,1,1,1},
  {1,0,1,0,0,0,1,0,0,1},
  {1,0,1,1,1,0,1,0,0,1},
  {1,0,0,0,0,0,1,0,0,1},
  {1,0,1,1,0,0,0,0,0,1},
  {1,0,0,1,0,1,1,1,0,1},
  {1,0,0,0,0,1,0,0,0,1},
  {1,0,1,1,1,1,0,1,1,1},
  {1,0,0,0,0,0,0,0,0,1},
  {1,1,1,1,1,1,1,1,1,1}};

Point kuma = new Point(5,4);
Point dragon = new Point(8,8);
Point sword = new Point(1,1);

PImage image_kuma;
PImage image_dragon;
PImage image_sword;

boolean have_sword = false;

String game_status = "playing";

long prev_time;
String move = "";

//
// 起動時に呼ばれる組み込み関数
//
void setup() {
  size(500,500);
  
  images = new PImage[]{ 
    loadImage("image0.png"),
    loadImage("image1.png")
   };

  image_kuma=   loadImage("kuma.png");
  image_dragon=   loadImage("dragon.png");
  image_sword=   loadImage("sword.png");


  prev_time = System.currentTimeMillis();
}


//
// 毎フレーム呼ばれる組み込み関数
//
void draw() {

  if (System.currentTimeMillis()-prev_time < 300)
    return;
  prev_time = prev_time + 300;

  update_position();
    
  for(int y=0; y<10; y++){
    for(int x=0; x<10; x++){
      image(images[map[x][y]], x*50, y*50);
    }
  }

  if (!have_sword)
    image(image_sword, sword.x*50, sword.y*50);
  image(image_dragon, dragon.x*50, dragon.y*50);
  image(image_kuma, kuma.x*50, kuma.y*50);
  
  
  if (game_status.equals("game_over")){
    draw_message("GAME OVER!");
  }
  else if (game_status.equals("game_clear")){
    draw_message("CONGLATURATIONS!");
  }
}


//
// テキストの表示
//
void draw_message(String message){
    textFont (createFont("MS Gothic",80,true));  // 文字のフォント
  fill(0);                                     // 文字の色
  textSize(24);                                // 文字のサイズ
  text(message,150, 240); 
}


//
//  くまの移動
//
void update_position(){

  if (!game_status.equals("playing"))
    return;

  if (move.equals("up")){
      move_kuma(kuma.x, kuma.y-1);
  }
  else if (move.equals("down")){
      move_kuma(kuma.x, kuma.y+1);
  }
  else if (move.equals("left")){
      move_kuma(kuma.x-1, kuma.y);
  }
  else if (move.equals("right")){
      move_kuma(kuma.x+1, kuma.y);
  }
  move = "";
  
  
  
  //
  // ゲームの進行
  //
  if (!have_sword){
    if (kuma.x == sword.x && kuma.y == sword.y){
      have_sword = true;
    }
    else if (kuma.x == dragon.x && kuma.y == dragon.y){
      game_status = "game_over";
    }
  }
  else {
    if (kuma.x == dragon.x && kuma.y == dragon.y){
      game_status = "game_clear";
    }
  }

}
//
// 壁でなければ移動する。
//
void move_kuma(int x, int y){
  if (map[x][y] != 1){
    kuma.x = x;
    kuma.y = y;
  }
}

//
// キー入力の処理
//
void keyPressed() 
{
  if (key == CODED) {
    if (keyCode == LEFT) {
      move = "left";
    } else if (keyCode == RIGHT) {
      move = "right";
    } else if (keyCode == UP) {
      move = "up";
    } else if (keyCode == DOWN) {
      move = "down";
    } 
  }
}